class GridRecordsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
  		 :method => :get, :only => [ :xml ],
         :redirect_to => { :action => :list }

  def xml_init
	@xm = Builder::XmlMarkup.new;
	@xm::instruct! # <?xml version="1.0" encoding="UTF-8"?>
  end
  	
  def xml
  	xml_init	
  	@xm.rows do 
  	  @xm.head do
		GridRecord.content_columns.each do |col|
		  @xm.column col.name,{"type"=>"ed", "width"=>"150"} 
	  	end
  	  end
  	  
  	  a_records = GridRecord.find(:all);
	  a_records.each do |record|
	  	@xm.tag! ("row",{ "id" => record.id }) do
	  	  GridRecord.content_columns.each do |col|
			@xm.cell record.send(col.name)
		  end  
		end
  	  end
  	end
  	
  	render_xml @xm.target!
  end

  def list
    @grid_record_pages, @grid_records = paginate :grid_records, :per_page => 10
  end

  def show
    @grid_record = GridRecord.find(params[:id])
  end

  def new
    @grid_record = GridRecord.new
  end

  def create
    @grid_record = GridRecord.new(params[:grid_record])
    if @grid_record.save
      flash[:notice] = 'GridRecord was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @grid_record = GridRecord.find(params[:id])
  end

  def update
    @grid_record = GridRecord.find(params[:id])
    if @grid_record.update_attributes(params[:grid_record])
      flash[:notice] = 'GridRecord was successfully updated.'
      redirect_to :action => 'show', :id => @grid_record
    else
      render :action => 'edit'
    end
  end

  def destroy
    GridRecord.find(params[:id]).destroy
    redirect_to :action => 'list'
  end
end
