require File.dirname(__FILE__) + '/../test_helper'
require 'grid_records_controller'

# Re-raise errors caught by the controller.
class GridRecordsController; def rescue_action(e) raise e end; end

class GridRecordsControllerTest < Test::Unit::TestCase
  fixtures :grid_records

  def setup
    @controller = GridRecordsController.new
    @request    = ActionController::TestRequest.new
    @response   = ActionController::TestResponse.new

    @first_id = grid_records(:first).id
  end

  def test_index
    get :index
    assert_response :success
    assert_template 'list'
  end

  def test_list
    get :list

    assert_response :success
    assert_template 'list'

    assert_not_nil assigns(:grid_records)
  end

  def test_show
    get :show, :id => @first_id

    assert_response :success
    assert_template 'show'

    assert_not_nil assigns(:grid_record)
    assert assigns(:grid_record).valid?
  end

  def test_new
    get :new

    assert_response :success
    assert_template 'new'

    assert_not_nil assigns(:grid_record)
  end

  def test_create
    num_grid_records = GridRecord.count

    post :create, :grid_record => {}

    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_equal num_grid_records + 1, GridRecord.count
  end

  def test_edit
    get :edit, :id => @first_id

    assert_response :success
    assert_template 'edit'

    assert_not_nil assigns(:grid_record)
    assert assigns(:grid_record).valid?
  end

  def test_update
    post :update, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'show', :id => @first_id
  end

  def test_destroy
    assert_nothing_raised {
      GridRecord.find(@first_id)
    }

    post :destroy, :id => @first_id
    assert_response :redirect
    assert_redirected_to :action => 'list'

    assert_raise(ActiveRecord::RecordNotFound) {
      GridRecord.find(@first_id)
    }
  end
end
